package com.engine.jucailinkq.attendance.component.page.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailinkq.common.util.DateUtil;
import com.engine.jucailinkq.common.util.DbTools;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.Calendar;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class GetPersonPageServiceCmd extends AbstractCommonCommand<Map<String,Object>> {


    public GetPersonPageServiceCmd(Map<String,Object> params, User user){
        this.params=params;
        this.user=user;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String generateDate = Util.null2String(params.get("generateDate"));
        String userId = Util.null2String(params.get("userId"));
        if ("".equals(userId)){
            userId = String.valueOf(user.getUID());
        }
        String nowDate = Util.null2String(params.get("nowDate"));
        if ("".equals(nowDate)){
            nowDate = DateUtil.getCurrentDate();
        }
        String nowYearDate = nowDate.split("-")[0]+"-01-01";
        String nowYearendDate = nowDate.split("-")[0]+"-12-31";


        Map<String,Object> resultMap = Maps.newHashMap();
        String sql = "select * from uf_jcl_kq_jqye where  ygid=? and yqsxrq>=? and sxrq<=?";
        List<Map<String, Object>> holidayDataList = DbTools.getSqlToList(sql,userId,nowDate,nowDate);
        Map<String,List<Map<String, Object>>> holidayDataGroup = holidayDataList.stream().collect(Collectors.groupingBy(e->e.get("jqid").toString()));
        Map<String,Map<String,Object>> holidayMap = Maps.newHashMap();
        sql = "select id,mc name from uf_jcl_kq_kqxm";
        Map<String,Object> itemMap = DbTools.getSqlToMapList(sql);
        for (Map.Entry<String,List<Map<String, Object>>> entry:holidayDataGroup.entrySet()){
            String jqid = entry.getKey();
            List<Map<String, Object>> dataList = entry.getValue();

            List<Map<String, Object>> oldData = dataList.stream().filter(e-> DateUtil.getTime(e.get("sxrq").toString())
                    .compareTo(DateUtil.getTime(nowYearDate)) <0).collect(Collectors.toList());

            List<Map<String, Object>> nowData = dataList.stream().filter(e-> DateUtil.getTime(e.get("sxrq").toString())
                    .compareTo(DateUtil.getTime(nowYearDate)) >=0 && DateUtil.getTime(e.get("sxrq").toString())
                    .compareTo(DateUtil.getTime(nowYearendDate)) <=0).collect(Collectors.toList());

            double allHoliday = dataList.stream().mapToDouble(e->Double.valueOf(e.get("wxsc").toString())).sum();
            double oldHoliday = oldData.stream().mapToDouble(e->Double.valueOf(e.get("wxsc").toString())).sum();
            double nowHoliday = allHoliday-oldHoliday;
            Map<String,Object> map = Maps.newHashMap();
            map.put("allHoliday",allHoliday);
            map.put("oldHoliday",oldHoliday);
            map.put("nowHoliday",nowHoliday);
            map.put("holidayName",Util.null2String(itemMap.get(jqid)));
            holidayMap.put(jqid,map);
        }
        resultMap.put("holiday",holidayMap);
        int diffdays = DateUtil.getDays(generateDate, Calendar.DAY_OF_MONTH);
        String startDate = generateDate + "-01";
        String endDate = generateDate + "-" + diffdays;

        sql = "select * from uf_jcl_kq_cqjg where ygid=? and rq>=? and rq<=?";
        List<Map<String,Object>> attendaceResultList = DbTools.getSqlToList(sql,userId,startDate,endDate);
        for (Map<String,Object> attendaceResult:attendaceResultList){
            Map<String,Object> attendaceResultItem = Maps.newHashMap();
            for (int i=1;i<=8;i++){
                String xm = "xm" + i;
                String sc = "sc" + i;
                String item = Util.null2String(attendaceResult.get(xm));
                if (!"".equals(item)){
                    String time = attendaceResult.get(sc).toString();
                    double havedAskforTime = attendaceResultItem.get(item) == null?0:Double.valueOf(attendaceResultItem.get(item).toString());
                    havedAskforTime = havedAskforTime+Double.valueOf(Util.null2String(time).equals("")?"1":Util.null2String(time));
                    attendaceResultItem.put(item,havedAskforTime);
                }
            }
            Map<String,Object> attendaceResultItemName = Maps.newHashMap();
            for (Map.Entry<String,Object> entry:attendaceResultItem.entrySet()){
                attendaceResultItemName.put(Util.null2String(itemMap.get(entry.getKey())),entry.getValue());
            }
            attendaceResult.put("attendaceResultItemName",attendaceResultItemName);
        }
        resultMap.put("attendaceResult",attendaceResultList);

        return resultMap;
    }
}
