package com.engine.jucailinkq.attendance.vacation.cmd;

import com.engine.jucailinkq.attendance.vacation.job.holidaygeneration.tactics.HolidayGenerationWay;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.jucailinkq.common.util.DbTools;
import com.engine.jucailinkq.common.util.Utils;
import com.engine.core.interceptor.CommandContext;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import weaver.general.Util;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Slf4j
public class VocationCmd extends AbstractCommonCommand<Map<String,Object>> {
    @Override
    public BizLogContext getLogContext() {
        return null;
    }
    public VocationCmd(Map<String,Object> params){
        this.params=params;
    }

    private List<HolidayGenerationWay> rulers;
    {
        rulers = new Utils<HolidayGenerationWay>().getAllClassByInterface(HolidayGenerationWay.class);

    }
    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        List<Map<String,Object>> vocationList = (List<Map<String,Object>>)params.get("vocationList");
        List<Map<String,Object>> userList = (List<Map<String,Object>>)params.get("userList");
        List<Map<String,Object>> userfilter = userList.stream().filter(e->"1".equals(e.get("scopeid"))).collect(Collectors.toList());
        Map<String,Object> userMap = userfilter.size()>0?userfilter.get(0):Maps.newHashMap();

        for (Map<String,Object> vocation : vocationList){
            log.debug("qsrq : [{}],yjzd : [{}]",vocation.get("qsrq"),vocation.get("yjzd"));
            String qsrq = Util.null2String(vocation.get("qsrq")).toLowerCase();
            String yjzd = Util.null2String(vocation.get("yjzd")).toLowerCase();
            String ljcrglyfslwz = Util.null2String(vocation.get("ljcrglyfslwz"));
            String lsgldw = Util.null2String(vocation.get("lsgldw"));
            String jzrqzd = Util.null2String(vocation.get("jzrqzd"));
            String jgsc = Util.null2String(vocation.get("jgsc"));
            String qsrqValue = Util.null2String(userMap.get(qsrq));
            String yjzdValue = Util.null2String(userMap.get(yjzd));
            String ljcrglyfslwzValue = Util.null2String(userMap.get(ljcrglyfslwz));
            String jzrqzdValue = Util.null2String(userMap.get(jzrqzd));
            if ("".equals(qsrqValue)){
                for (Map<String,Object> map: userList){
                    qsrqValue = Util.null2String(map.get(qsrq));
                    if (!"".equals(qsrqValue)){
                        break;
                    }
                }
            }
            if ("".equals(yjzdValue)){
                for (Map<String,Object> map: userList){
                    yjzdValue = Util.null2String(map.get(yjzd));
                    if (!"".equals(yjzdValue)){
                        break;
                    }
                }
            }
            if ("".equals(ljcrglyfslwzValue)){
                for (Map<String,Object> map: userList){
                    ljcrglyfslwzValue = Util.null2String(map.get(ljcrglyfslwz));
                    if (!"".equals(ljcrglyfslwzValue)){
                        break;
                    }
                }
            }
            if ("".equals(jzrqzdValue)){
                for (Map<String,Object> map: userList){
                    jzrqzdValue = Util.null2String(map.get(jzrqzd));
                    if (!"".equals(jzrqzdValue)){
                        break;
                    }
                }
            }

            vocation.put("jzrqzdValue",jzrqzdValue);
            vocation.put("qsrqValue",qsrqValue);
            vocation.put("yjzdValue",yjzdValue);
            vocation.put("ljcrglyfslwzValue",ljcrglyfslwzValue);
            //lsgldw:累时工龄单位：0：年；1：月
            //ljcrglyfslwzValue：累时工龄值：浮点数
            //jgsc：间隔时长算法：0：起算日期于当前日期间隔；1：起算日期与当前日期间隔额外加上累时工龄值；2：直接取累时工龄浮点值
            if (!"".equals(lsgldw) && !"".equals(ljcrglyfslwzValue) && "0".equals(lsgldw) && "1".equals(jgsc)){
                //当累计单位为年时 累计工龄的处理
                vocation.put("ljcrglyfslwzValue",Math.round(Double.valueOf(ljcrglyfslwzValue)*12));
            }
            if ("0".equals(jgsc)){
                //起算日期与当前日期间隔不取 直取间隔时长
                vocation.put("ljcrglyfslwzValue","0");
            }

           // vocation.put("zyzValue",getUserIds(vocation));
        }
        log.debug("VocationCmd params: [{}]",params);
        String edfffs = Util.null2String(vocationList.get(0).get("edfffs"));
        for (HolidayGenerationWay holidayGenerationWay :rulers){
            if (holidayGenerationWay.support(Integer.valueOf(edfffs))){
                holidayGenerationWay.compute(params);
            }
        }

        return null;
    }

}
