package com.engine.jucailinkq.attendance.workflow.action;

import com.engine.common.util.ServiceUtil;
import com.engine.jucailinkq.attendance.attendanceanalysis.service.UtilService;
import com.engine.jucailinkq.attendance.attendanceanalysis.service.impl.UtilServiceImpl;
import com.engine.jucailinkq.attendance.enums.*;
import com.engine.jucailinkq.attendance.workflow.service.MakeUpClockInService;
import com.engine.jucailinkq.attendance.workflow.service.impl.MakeUpClockInServiceImpl;
import com.engine.jucailinkq.common.util.CommonUtil;
import com.engine.jucailinkq.common.util.DateUtil;
import com.engine.jucailinkq.common.util.DbTools;
import com.engine.jucailinkq.common.util.Utils;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 加班计划流程退回
 * @author sy
 */
@Slf4j
public class OvertimePlanBackAction implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
        String requestId = requestInfo.getRequestid();
        try {
            //收集加班计划中流程id关联的数据
            String sql = "select id from uf_jcl_kq_jbjh where lyid = " + requestId;
            List<Map<String, Object>> jbjhData = DbTools.getSqlToList(sql);
            List<String> jbjhIdList = jbjhData.stream().map(f->f.get("id").toString()).collect(Collectors.toList());
            if (jbjhIdList.size() > 0) {
                //删除加班计划明细表
                sql = "delete from uf_jcl_kq_jbjh_dt1 where mainid in (" + String.join(",",jbjhIdList) + ")";
                boolean delSign1 = DbTools.update(sql);
                String message = "";
                if (!delSign1) {
                    message = message + "删除加班计划明细表数据失败！";
                }
                //删除加班计划表
                sql = "delete from uf_jcl_kq_jbjh where id in (" + String.join(",",jbjhIdList) + ")";
                boolean delSign2 = DbTools.update(sql);
                if (!delSign2) {
                    message = message + "删除加班计划主表数据失败！";
                }
                //删除加班结果中加班计划转换的数据
                sql = "delete from uf_jcl_kq_jbjg where jbjhid in (" + String.join(",",jbjhIdList) + ")";
                boolean delSign3 = DbTools.update(sql);
                if (!delSign3) {
                    message = message + "删除加班结果表数据失败！";
                }
                if (!delSign1 || !delSign2 || !delSign3) {
                    log.error(message);
                    requestInfo.getRequestManager().setMessageid("11111" + requestInfo.getRequestid() + "22222");
                    requestInfo.getRequestManager().setMessagecontent(message);
                    return Action.FAILURE_AND_CONTINUE;
                }
            }

        }catch (Exception e){
            log.error("OvertimePlanBackAction error : [{}]", e.getMessage());
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

}
