package com.engine.jucailinkq.common.util;

import com.engine.jucailinkq.attendance.attendanceanalysis.cmd.getclockInpoint.biz.AbstractAdjustClockPointAction;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 扩展类
 */
public class ExtensionClassHolder {
    /**
     * 打卡卡点扩展类
     */
    private static ThreadLocal<List<AbstractAdjustClockPointAction>> adjustClockPointActionThreadLocal = new ThreadLocal<>();


    /**
     * 全局设置变量
     */
    private static ThreadLocal<Map<String,Object>> globalSetMapThreadLocal = new ThreadLocal<>();

    /**
     * 人员对应人员分组
     */
    private static ThreadLocal<Map<String,List<Map<String,Object>>>> personBelongGroupThreadLocal = new ThreadLocal<>();

    /**
     * 人员对应人员信息
     */
    private static ThreadLocal<Map<String,Map<String,Object>>> personInformationThreadLocal = new ThreadLocal<>();

    /**
     * 部门对应上级部门
     */
    private static ThreadLocal<Map<String,String>> petDepartThreadLocal= new ThreadLocal<>();



    public static void setAdjustClockPointAction(List<AbstractAdjustClockPointAction> adjustClockPointActionList) {
        adjustClockPointActionThreadLocal.set(adjustClockPointActionList);
    }

    public static List<AbstractAdjustClockPointAction> getAdjustClockPointAction() {
        return adjustClockPointActionThreadLocal.get();
    }

    public static void setGlobalSetMap(Map<String,Object> map) {
        globalSetMapThreadLocal.set(map);
    }

    public static Map<String,Object> getGlobalSetMap() {
        return globalSetMapThreadLocal.get();
    }

    public static Map<String, List<Map<String, Object>>> getPersonBelongGroupThreadLocal() {
        return personBelongGroupThreadLocal.get();
    }

    public static void setPersonBelongGroupThreadLocal(Map<String, List<Map<String, Object>>> personBelongGroupMap) {
        personBelongGroupThreadLocal.set(personBelongGroupMap);
    }

    public static Map<String, Map<String, Object>> getPersonInformationThreadLocal() {
        return personInformationThreadLocal.get();
    }

    public static void setPersonInformationThreadLocal(Map<String, Map<String, Object>> personInformationThreadLocal) {
        ExtensionClassHolder.personInformationThreadLocal.set(personInformationThreadLocal);
    }

    public static Map<String, String> getPetDepartMentThreadLocal() {
        return petDepartThreadLocal.get();
    }

    public static void setPetDepartMentThreadLocal(Map<String, String> petDepartMent) {
        ExtensionClassHolder.petDepartThreadLocal.set(petDepartMent);
    }
}
